<Cabbage>
#define PLANT colour(76,130,180,155) outlinecolour(0,0,0,255) outlinethickness(2)
#define BASIC colour(56, 150, 180, 255) trackercolour(56,255,182,255) outlinecolour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackercolour(56,255,182,255) outlinecolour(17,37,37,155)
#define FTABLES tablegridcolour("Silver") tablecolour:0(20,20,20,245) tablebackgroundcolour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey") fontcolour("Gainsboro")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0)
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) 
#define FONT fontcolour("Gainsboro")
#define RSLIDER colour(56, 150, 180, 255) trackercolour("MediumTurquoise") fontcolour("Gainsboro") valuetextbox(1) textboxcolour("black") 

form caption("MVerb") size(535, 415) colour(76,130,180,155) outlinecolour(0,0,0,255) outlinethickness(2) pluginid("MVerb") fontcolour("white") style("legacy") 

image bounds(5,5,145,205) plant("main") $PLANT
{
label bounds(14,7,55,15) text("Presets") $FONT
filebutton bounds(85,3,40,20), channel("preset"), text("Save"), mode("snapshot")
combobox bounds(15,25,110,20), channel("combobox"), populate("*.snaps") $FONT
button bounds(22,48,30,15) text("Size") channel("mapDFact") $MIDI
button bounds(52,48,9,15) text("") channel("mapDFactX") $MIDIX
rslider bounds(10,65,60,45) channel("DFact") range(.01,2,1,1,.001) $RSLIDER
button bounds(80,48,30,15) text("Decay") channel("mapFB") $MIDI
button bounds(110,48,9,15) text("") channel("mapFBX") $MIDIX
rslider bounds(71,65,60,45) channel("FB") range(0,1,0.541,4,0.001) $RSLIDER 
label bounds(14,115,105,15) text("Early Reflection") $FONT
combobox bounds(15,135,110,20) value(2) channel("ERSelect") items("None","Small","Medium","Large","Huge","Long Random","Short Backwards","Long Backwards","Strange1","Strange2") $FONT
button bounds(70,167,30,15) text("Amp") channel("mapERamp") $MIDI
button bounds(100,167,9,15) text("") channel("mapERampX") $MIDIX
rslider bounds(20,160,60,45) channel("ERamp") range(0,1.5,.9,1,.001) $RSLIDER
}

image bounds(155,5,140,98) plant("EQ") $PLANT
{
label bounds(5,4,40,15) text("Filter") $FONT
combobox bounds(50,4,85,14) channel("filtsel") value(1) text("Low Shelf","High Shelf","Peak","Low Pass","High Pass","Band Pass","Band Reject","Bypass/Off") $FONT
button bounds(22,24,32,15) text("Freq") channel("mapf1") $MIDI
button bounds(54,24,9,15) text("") channel("mapf1X") $MIDIX
rslider bounds(10,40,65,45) channel("f1") range(20,20000,10000,.5,1) $RSLIDER
button bounds(85,24,32,15) text("Q") channel("mapQ") identchannel("Qa") visible(0) $MIDI
button bounds(117,24,9,15) text("") channel("mapQX") identchannel("Qb")visible(0) $MIDIX
rslider bounds(72,40,65,45) channel("Q") range(.5,99,.5,1,.1) identchannel("Qc") visible(0) $RSLIDER
button bounds(85,24,32,15) text("Q") channel("mapQ2") identchannel("Q2a") visible(0) $MIDI
button bounds(117,24,9,15) text("") channel("mapQ2X") identchannel("Q2b") visible(0) $MIDIX
rslider bounds(72,40,65,45) channel("Q2") range(.5,.999,.5,1,.001) identchannel("Q2c") visible(0) $RSLIDER
button bounds(85,24,32,15) text("boost") channel("mapboost") identchannel("boosta") visible(1) $MIDI
button bounds(117,24,9,15) text("") channel("mapboostX") identchannel("boostb") visible(1) $MIDIX 
rslider bounds(72,40,65,45) channel("boost") range(.5,1.5,1,1,.01) identchannel("boostc") visible(1) $RSLIDER
}

image bounds(300,5,230,50) plant("input") $PLANT
{
button bounds(5,3,55,20) channel("sfplay") text("Play SF") $BUTTONS
filebutton bounds(65,3,37,13) channel("openFile") text("Load") $BUTTONS
button bounds(65,18,37,13) channel("sfloop") text("Loop") $BUTTONS
button bounds(65,33,37,13) channel("sfback") text("Back") $BUTTONS
rslider bounds(95,2,50,45) channel("sfspeed") range(.25,4,1,.5,.001) $RSLIDER
button bounds(142,3,37,15) text("SF Speed") channel("mapsfspeed") $MIDI
button bounds(179,3,9,15) text("") channel("mapsfspeedX") $MIDIX
button bounds(5,26,55,20) channel("liveon") text("Mic/Line") $BUTTONS
button bounds(142,32,37,15) text("Amp") channel("mapliveamp") $MIDI
button bounds(179,32,9,15) text("") channel("mapliveampX") $MIDIX
rslider bounds(185,2,50,45) channel("liveamp") range(0,5,.75,0.75,0.001) $RSLIDER
}

image bounds(300,60,230,42) plant("MeshIn") $PLANT
{
label bounds(15,14,20,12) text("In") $FONT
label bounds(10,2,30,12) text("1-4") $FONT
label bounds(10,26,30,12) text("5-8") $FONT
combobox bounds(50,3,33,14) channel("in1") value(2) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(90,3,33,14) channel("in2") value(4) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(130,3,33,14) channel("in3") value(6) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(170,3,33,14) channel("in4") value(10) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(50,24,33,14) channel("in5") value(16) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(90,24,33,14) channel("in6") value(20) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(130,24,33,14) channel("in7") value(22) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(170,24,33,14) channel("in8") value(24) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
}

image bounds(5,215,145,100) plant("randomize") $PLANT
{
button bounds(22,5,100,20) channel("random") text("Moving Mesh") $BUTTONS
button bounds(11,30,30,15) text("Range") channel("maprmax") $MIDI
button bounds(41,30,9,15) text("") channel("maprmaxX") $MIDIX
rslider bounds(0,48,60,45) channel("rmax") range(0,.95,.1,1,.01) $RSLIDER
button bounds(56,30,27,15) text("Rate") channel("maprrate") $MIDI
button bounds(81,30,9,15) text("") channel("maprrateX") $MIDIX
rslider bounds(43,48,60,45) channel("rrate") range(.05,250,.5,.25,.01) $RSLIDER
button bounds(95,30,27,15) text("R Dev") channel("maprratedev") $MIDI
button bounds(122,30,9,15) text("") channel("maprratedevX") $MIDIX
rslider bounds(84,48,60,45) channel("rratedev") range(0,.95,.1,1,.01) $RSLIDER
}

image bounds(155,105,375,210) plant("ResF") $PLANT
{
label bounds(45,5,300,15) text("5x5 mesh reverb resonant frenquencies") $FONT
label bounds(10,32,45,15) text("1-5") $FONT
label bounds(10,62,45,15) text("6-10") $FONT
label bounds(7,92,45,15) text("11-15") $FONT
label bounds(5,122,45,15) text("16-20") $FONT
label bounds(5,152,45,15) text("21-25") $FONT
nslider bounds(50,30,60,20) channel("res1") range(2,20000,102,0.5,0.01) value(102) $FONT
nslider bounds(112,30,60,20) channel("res2") range(2,20000,435,0.5,0.01) value(435) $FONT
nslider bounds(174,30,60,20) channel("res3") range(2,20000,735,0.5,0.01) value(735) $FONT
nslider bounds(238,30,60,20) channel("res4") range(2,20000,76.8,0.5,0.01) value(76.8) $FONT
nslider bounds(300,30,60,20) channel("res5") range(2,20000,114,0.5,0.01) value(114) $FONT
nslider bounds(50,60,60,20) channel("res6") range(2,20000,669.2,0.5,0.01) value(669.2) $FONT
nslider bounds(112,60,60,20) channel("res7") range(2,20000,739.7,0.5,0.01) value(739.7) $FONT
nslider bounds(174,60,60,20) channel("res8") range(2,20000,843.6,0.5,0.01) value(843.6) $FONT
nslider bounds(238,60,60,20) channel("res9") range(2,20000,272.72,0.5,0.01) value(272.72) $FONT
nslider bounds(300,60,60,20) channel("res10") range(2,20000,114.3,0.5,0.01) value(114.3) $FONT
nslider bounds(50,90,60,20) channel("res11") range(2,20000,963.2,0.5,0.01) value(963.2) $FONT
nslider bounds(112,90,60,20) channel("res12") range(2,20000,250.3,0.5,0.01) value(250.3) $FONT
nslider bounds(174,90,60,20) channel("res13") range(2,20000,373.73,0.5,0.01) value(373.73) $FONT
nslider bounds(238,90,60,20) channel("res14") range(2,20000,842,0.5,0.01) value(842) $FONT
nslider bounds(300,90,60,20) channel("res15") range(2,20000,999,0.5,0.01) value(999) $FONT
nslider bounds(50,120,60,20) channel("res16") range(2,20000,621,0.5,0.01) value(621) $FONT
nslider bounds(112,120,60,20) channel("res17") range(2,20000,210,0.5,0.01) value(210) $FONT
nslider bounds(174,120,60,20) channel("res18") range(2,20000,183,0.5,0.01) value(183) $FONT
nslider bounds(238,120,60,20) channel("res19") range(2,20000,578,0.5,0.01) value(578) $FONT
nslider bounds(300,120,60,20) channel("res20") range(2,20000,313,0.5,0.01) value(313) $FONT
nslider bounds(50,150,60,20) channel("res21") range(2,20000,792,0.5,0.01) value(792) $FONT
nslider bounds(112,150,60,20) channel("res22") range(2,20000,159.3,0.5,0.01) value(159.3) $FONT
nslider bounds(174,150,60,20) channel("res23") range(2,20000,401.5,0.5,0.01) value(401.5) $FONT
nslider bounds(238,150,60,20) channel("res24") range(2,20000,733,0.5,0.01) value(733) $FONT
nslider bounds(300,150,60,20) channel("res25") range(2,20000,1010,0.5,0.01) value(1010) $FONT
rslider bounds(10,177,30,30) channel("port") range(.01,10,.5,.5,.01) colour(56, 150, 180, 255) trackercolour("MediumTurquoise") textcolour("white")
button bounds(45,188,62,15) text("Portamento") channel("mapport") $MIDI
button bounds(107,188,9,15) text("") channel("mapportX") $MIDIX
rslider bounds(130,177,30,30) channel("disp") range(0,.95,.375,1,.001) colour(56, 150, 180, 255) trackercolour("MediumTurquoise") textcolour("white")
button bounds(165,173,25,14) channel("dispon") text("off","on") value(1) $BUTTONS
button bounds(165,188,62,15) text("Dispersion") channel("mapdisp") $MIDI
button bounds(227,188,9,15) text("") channel("mapdispX") $MIDIX
button bounds(255,182,105,22) channel("FBclear") text("Anti-Feedback") latched(1) $BUTTONS
}

image bounds(5,320,145,90) plant("surprise") $PLANT
{
button bounds(8,5,130,20) channel("randres") text("Random Resonances") latched(0) $BUTTONS
hrange bounds(2,30,143,30) channel("low","high") range(2,20000,20:10000,.5,.1) texbox(1) caption("Random F Range") $VBASIC
nslider bounds(5,65,60,20) channel("low") range(2,20000,20,.5,.1) $FONT
nslider bounds(80,65,60,20) channel("high") range(2,20000,10000,.5,.1) $FONT
}

image bounds(155,320,140,90) plant("mix") $PLANT
{
button bounds(52,15,27,15) text("Mix") channel("mapmix") $MIDI
button bounds(79,15,9,15) text("") channel("mapmixX") $MIDIX
rslider bounds(41,31,55,45) channel("mix") range(0,1,0.75,1,0.001) value(0.75) $RSLIDER
}

image bounds(300,320,230,40) plant("record") $PLANT
{
button bounds(5,3,70,30) channel("record") text("Record","Stop") $BUTTONS
button bounds(80,3,70,30) channel("play") text("Play") $BUTTONS
combobox bounds(155,3,65,15) channel("recch") value(2) text("mono","stereo","3 channel","4 channel","5 channel","6 channel","7 channel","8 channel") $FONT
combobox bounds(155,20,65,15) channel("bit") value(1) text("16-bit","24-bit","32-bit") $FONT
}

image bounds(300,365,230,45) plant("MeshOut") $PLANT
{
label bounds(15,14,20,12) text("Out") $FONT
label bounds(10,2,30,12) text("1-4") $FONT
label bounds(10,26,30,12) text("5-8") $FONT
combobox bounds(50,3,33,14) channel("out1") value(2) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(90,3,33,14) channel("out2") value(4) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(130,3,33,14) channel("out3") value(6) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(170,3,33,14) channel("out4") value(10) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(50,24,33,14) channel("out5") value(16) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(90,24,33,14) channel("out6") value(20) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(130,24,33,14) channel("out7") value(22) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
combobox bounds(170,24,33,14) channel("out8") value(24) text("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25") $FONT
}


</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-d -n -+rtmidi=NULL -M0 -m0d
</CsOptions>
<CsInstruments>

;sr = 44100
ksmps = 50
nchnls = 8
0dbfs = 1

ga1mix,ga2mix,ga3mix,ga4mix,ga5mix,ga6mix,ga7mix,ga8mix init 0
garev1,garev2,garev3,garev4,garev5,garev6,garev7,garev8 init 0
gamic1,gamic2,gamic3,gamic4,gamic5,gamic6,gamic7,gamic8 init 0
gichnls,giReady,gifilelen init 0 ;globals for soundfile table loading
gSfilepath init ""
giTable init 500
gkTabLen init 2
gkRecordingActiveFlag,gkFileRecorded init 0

opcode Alpaz, a,aki
a1, kg1, iM1 xin
adel1 init   0
aout = adel1+(-kg1*a1)
adel1 delay  a1+(kg1*aout), iM1 
xout aout
endop

opcode EQ,a,a ;1 audio out, 1 audio in ;get k-rate data through chnget arguments
ain	xin
kfiltsel chnget "filtsel"
kboost    chnget  "boost"
kboost    port    2-kboost,.05
kf1 chnget "f1"
kf1 port kf1,.05
kQ chnget "Q"
kQ port kQ,.05
if kfiltsel==1 then
afilt    pareq    ain,kf1,kboost,.5,1
elseif kfiltsel==2 then
afilt    pareq    ain,kf1,kboost,.5,2
elseif kfiltsel==3 then
afilt    pareq    ain,kf1,kboost,kQ,0
elseif kfiltsel==4 then
afilt    tone     ain,kf1
elseif kfiltsel==5 then
afilt    atone    ain,kf1
elseif kfiltsel==6 then
afilt    reson    ain,kf1,kf1/(kQ*.1)
elseif kfiltsel==7 then
afilt    areson   ain,kf1,kf1/(kQ*.1)
elseif kfiltsel==8 then
afilt=ain
endif
aout balance  afilt,ain ;feedback without the balance embeded
aout dcblock2 aout
xout    aout
endop

opcode  meshEQ,aaaaa,aaaaaak ;5 audio outs and 6 audio ins one k-rate in for FB value, use for boundary nodes
aUin,aRin,aDin,aLin,aSin,adel,kFB xin ;U=up, R=right, D=down, L=left, S=source input, del=delay
afactor=(aUin+aRin+aDin+aLin+aSin)*-.5	;calculate raw value
aUout   vdelay  aUin+afactor,adel,1000	;calculate outputs
aRout   vdelay  aRin+afactor,adel,1000
aDout   vdelay  aDin+afactor,adel,1000
aLout   vdelay  aLin+afactor,adel,1000
aUout   EQ  aUout   ;apply EQ on each output
aRout   EQ  aRout
aDout   EQ  aDout
aLout   EQ  aLout
kalpg chnget "disp"
kdispon chnget "dispon"
if kdispon==0 goto OUT
aUout Alpaz aUout, kalpg, random(0.005,0.075)
aRout Alpaz aRout, kalpg, random(0.005,0.075)
aDout Alpaz aDout, kalpg, random(0.005,0.075)
aLout Alpaz aLout, kalpg, random(0.005,0.075)
OUT:
xout	aUout*kFB,aRout*kFB,aDout*kFB,aLout*kFB,afactor ;afactor serves as the audio tap for output
endop

opcode randomdel,a,a
adel xin
krand chnget "random"
krrate chnget "rrate"
krrate port krrate,.05
krratedev chnget "rratedev"
krratedev port krratedev,.05
krmax chnget "rmax"
krmax port krmax,.05
if krand=1 then
krdev=krrate*krratedev
krdev2 randh krdev,krrate,2 ;calculate random cps
adelayA randi krmax,krrate+krdev,2 
adel=adel+(adel*adelayA)
else
xout adel
endif
endop

instr 1 ;activate live audio input 
kliveon chnget "liveon"
if changed(kliveon) == 1 then
  if kliveon=1 then
  turnoff2 4,2,0
  event "i",4,0,999999
  else 
  turnoff2 4,2,0
  endif
endif

kplay   chnget  "sfplay"
gSfilepath chnget "openFile"
    
if changed(gSfilepath) == 1 then ;loads soundfile
    SIdentString sprintfk "file(\"%s\")", gSfilepath
    chnset SIdentString, "SFfiler"
    event   "i",3,0,0
endif
        
if changed(kplay) == 1 then ;turns on soundfile player
    if kplay=1 then 
    event "i",2,0,10000
    else
    turnoff2  2,0,.05
    endif
endif

gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",60,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",61,ksmps/sr,3600
  endif
  
krandres chnget "randres"
if changed(krandres)==1 then
  if krandres=1 then
  event "i",6,0,.001
  endif
endif

;filter GUI visible controls follow:
kfiltsel chnget "filtsel"
if changed(kfiltsel)==1 then
 if kfiltsel=1 then
  chnset "visible(1)", "boosta"
  chnset "visible(1)", "boostb"
  chnset "visible(1)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=2 then
  chnset "visible(1)", "boosta"
  chnset "visible(1)", "boostb"
  chnset "visible(1)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=3 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(1)", "Qa"
  chnset "visible(1)", "Qb"
  chnset "visible(1)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=4 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=5 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(0)", "Q2a"
  chnset "visible(0)", "Q2b"
  chnset "visible(0)", "Q2c"
 elseif kfiltsel=6 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(1)", "Q2a"
  chnset "visible(1)", "Q2b"
  chnset "visible(1)", "Q2c"
 elseif kfiltsel=7 then
  chnset "visible(0)", "boosta"
  chnset "visible(0)", "boostb"
  chnset "visible(0)", "boostc"
  chnset "visible(0)", "Qa"
  chnset "visible(0)", "Qb"
  chnset "visible(0)", "Qc"
  chnset "visible(1)", "Q2a"
  chnset "visible(1)", "Q2b"
  chnset "visible(1)", "Q2c"
 endif
endif     
endin

instr 2
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget  "liveamp"
kEnv linsegr 0,.05,1,p3-.05,1,.1,0
ksfspeed chnget "sfspeed"
ksfspeed port ksfspeed,.005
ksfback chnget "sfback"
if ksfback==0 then
 if gichnls==1 then
    a1	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==2 then
    a1,a2	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==3 then
    a1,a2,a3	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==4 then
   a1,a2,a3,a4	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==5 then
   a1,a2,a3,a4,a5	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==6 then
   a1,a2,a3,a4,a5,a6	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==7 then
   a1,a2,a3,a4,a5,a6,a7	diskin2	gSfilepath,ksfspeed,0,iloop
 elseif gichnls==8 then
   a1,a2,a3,a4,a5,a6,a7,a8	diskin2	gSfilepath,ksfspeed,0,iloop
 endif
elseif ksfback==1 then
 if gichnls==1 then
    a1	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==2 then
    a1,a2	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==3 then
    a1,a2,a3	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==4 then
   a1,a2,a3,a4	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==5 then
   a1,a2,a3,a4,a5	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==6 then
   a1,a2,a3,a4,a5,a6	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==7 then
   a1,a2,a3,a4,a5,a6,a7	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 elseif gichnls==8 then
   a1,a2,a3,a4,a5,a6,a7,a8	diskin2	gSfilepath,-ksfspeed,gifilelen,iloop
 endif
endif
asf1=a1*kingain*kEnv
asf2=a2*kingain*kEnv
asf3=a3*kingain*kEnv
asf4=a4*kingain*kEnv
asf5=a5*kingain*kEnv
asf6=a6*kingain*kEnv
asf7=a7*kingain*kEnv
asf8=a8*kingain*kEnv
ga1mix=asf1+ga1mix 
ga2mix=asf2+ga2mix
ga3mix=asf3+ga3mix 
ga4mix=asf4+ga4mix
ga5mix=asf5+ga5mix 
ga6mix=asf6+ga6mix
ga7mix=asf7+ga7mix 
ga8mix=asf8+ga8mix
endin

instr 3
gichnls filenchnls  gSfilepath
gifilelen filelen gSfilepath
giReady=1 ;default if no string has been loaded yet
gkTabLen init ftlen(giTable)/gichnls
Smessage sprintfk "file(%s)",gSfilepath
endin

instr 4 ;live audio input and live granulation engine--also takes signal from the synth module and the SF granulation module for re-granulation
kliveamp chnget "liveamp"

ain1,ain2,ain3,ain4,ain5,ain6,ain7,ain8 ino ;mic/live audio inputs
ain1=ain1*kliveamp
ain2=ain2*kliveamp
ain3=ain3*kliveamp
ain4=ain4*kliveamp
ain5=ain5*kliveamp
ain6=ain6*kliveamp
ain7=ain7*kliveamp
ain8=ain8*kliveamp

ga1mix=dcblock2(ga1mix+ain1)  ;add into global audio mix
ga2mix=dcblock2(ga2mix+ain2)
ga3mix=dcblock2(ga3mix+ain3)
ga4mix=dcblock2(ga4mix+ain4)
ga5mix=dcblock2(ga5mix+ain5)
ga6mix=dcblock2(ga6mix+ain6)
ga7mix=dcblock2(ga7mix+ain7)
ga8mix=dcblock2(ga8mix+ain8)
endin

instr 5 ;global live/FX mix 
gkFX  chnget  "mix"
gksource=1-gkFX
endin

instr 6 ;generate random delay values within set range
klow chnget "low"
khigh chnget "high"
chnset random(klow,khigh),"res1"	  
chnset random(klow,khigh),"res2"    
chnset random(klow,khigh),"res3"   
chnset random(klow,khigh),"res4"
chnset random(klow,khigh),"res5"
chnset random(klow,khigh),"res6"  
chnset random(klow,khigh),"res7"
chnset random(klow,khigh),"res8"
chnset random(klow,khigh),"res9"
chnset random(klow,khigh),"res10"
chnset random(klow,khigh),"res11"   
chnset random(klow,khigh),"res12"   
chnset random(klow,khigh),"res13" 
chnset random(klow,khigh),"res14" 
chnset random(klow,khigh),"res15"
chnset random(klow,khigh),"res16" 
chnset random(klow,khigh),"res17"
chnset random(klow,khigh),"res18"
chnset random(klow,khigh),"res19"
chnset random(klow,khigh),"res20"
chnset random(klow,khigh),"res21"   
chnset random(klow,khigh),"res22"   
chnset random(klow,khigh),"res23" 
chnset random(klow,khigh),"res24" 
chnset random(klow,khigh),"res25"
endin

instr 10    ;5x5 mesh
;make multi-channel options both for sound input and output

a1U,a1R,a1D,a1L,a1s init 0 ;initialize all inputs for mesh
a2U,a2R,a2D,a2L,a2s init 0
a3U,a3R,a3D,a3L,a3s init 0
a4U,a4R,a4D,a4L,a4s init 0
a5U,a5R,a5D,a5L,a5s init 0
a6U,a6R,a6D,a6L,a6s init 0
a7U,a7R,a7D,a7L,a7s init 0
a8U,a8R,a8D,a8L,a8s init 0
a9U,a9R,a9D,a9L,a9s init 0
a10U,a10R,a10D,a10L,a10s init 0
a11U,a11R,a11D,a11L,a11s init 0
a12U,a12R,a12D,a12L,a12s init 0
a13U,a13R,a13D,a13L,a13s init 0
a14U,a14R,a14D,a14L,a14s init 0
a15U,a15R,a15D,a15L,a15s init 0
a16U,a16R,a16D,a16L,a16s init 0
a17U,a17R,a17D,a17L,a17s init 0
a18U,a18R,a18D,a18L,a18s init 0
a19U,a19R,a19D,a19L,a19s init 0
a20U,a20R,a20D,a20L,a20s init 0
a21U,a21R,a21D,a21L,a21s init 0
a22U,a22R,a22D,a22L,a22s init 0
a23U,a23R,a23D,a23L,a23s init 0
a24U,a24R,a24D,a24L,a24s init 0
a25U,a25R,a25D,a25L,a25s init 0

kDFact  chnget  "DFact"
kDFact  port    kDFact,.25
kFB chnget  "FB"
kFB port    kFB,.25
;;;"clear delays" coefficient
kdelclear   chnget  "FBclear"
kdelclear   port    kdelclear,.1
kFB=kFB*(1-kdelclear)
kER chnget "ERSelect"
kERamp chnget "ERamp"

;channels: random (on/off), rslow, rfast, rmax 
kport chnget "port"
kres1   chnget  "res1"
kres1 portk kres1,kport
adel1=kDFact*(1000/kres1)
adel1 randomdel adel1
kres2   chnget  "res2"
kres2 portk kres2,kport
adel2=kDFact*(1000/kres2)
adel2 randomdel adel2
kres3   chnget  "res3"
kres3 portk kres3,kport
adel3=kDFact*(1000/kres3)
adel3 randomdel adel3
kres4   chnget  "res4"
kres4 portk kres4,kport
adel4=kDFact*(1000/kres4)
adel4 randomdel adel4
kres5   chnget  "res5"
kres5 portk kres5,kport
adel5=kDFact*(1000/kres5)
adel5 randomdel adel5
kres6   chnget  "res6"
kres6 portk kres6,kport
adel6=kDFact*(1000/kres6)
adel6 randomdel adel6
kres7   chnget  "res7"
kres7 portk kres7,kport
adel7=kDFact*(1000/kres7)
adel7 randomdel adel7
kres8   chnget  "res8"
kres8 portk kres8,kport
adel8=kDFact*(1000/kres8)
adel8 randomdel adel8
kres9   chnget  "res9"
kres9 portk kres9,kport
adel9=kDFact*(1000/kres9)
adel9 randomdel adel9
kres10   chnget  "res10"
kres10 portk kres10,kport
adel10=kDFact*(1000/kres10)
adel10 randomdel adel10
kres11   chnget  "res11"
kres11 portk kres11,kport
adel11=kDFact*(1000/kres11)
adel11 randomdel adel11
kres12   chnget  "res12"
kres12 portk kres12,kport
adel12=kDFact*(1000/kres12)
adel12 randomdel adel12
kres13   chnget  "res13"
kres13 portk kres13,kport
adel13=kDFact*(1000/kres13)
adel13 randomdel adel13
kres14   chnget  "res14"
kres14 portk kres14,kport
adel14=kDFact*(1000/kres14)
adel14 randomdel adel14
kres15   chnget  "res15"
kres15 portk kres15,kport
adel15=kDFact*(1000/kres15)
adel15 randomdel adel15
kres16   chnget  "res16"
kres16 portk kres16,kport
adel16=kDFact*(1000/kres16)
adel16 randomdel adel16
kres17   chnget  "res17"
kres17 portk kres17,kport
adel17=kDFact*(1000/kres17)
adel17 randomdel adel17
kres18   chnget  "res18"
kres18 portk kres18,kport
adel18=kDFact*(1000/kres18)
adel18 randomdel adel18
kres19   chnget  "res19"
kres19 portk kres19,kport
adel19=kDFact*(1000/kres19)
adel19 randomdel adel19
kres20   chnget  "res20"
kres20 portk kres20,kport
adel20=kDFact*(1000/kres20)
adel20 randomdel adel20
kres21   chnget  "res21"
kres21 portk kres21,kport
adel21=kDFact*(1000/kres21)
adel21 randomdel adel21
kres22   chnget  "res22"
kres22 portk kres22,kport
adel22=kDFact*(1000/kres22)
adel22 randomdel adel22
kres23   chnget  "res23"
kres23 portk kres23,kport
adel23=kDFact*(1000/kres23)
adel23 randomdel adel23
kres24   chnget  "res24"
kres24 portk kres24,kport
adel24=kDFact*(1000/kres24)
adel24 randomdel adel24
kres25   chnget  "res25"
kres25 portk kres25,kport
adel25=kDFact*(1000/kres25)
adel25 randomdel adel25

;10 Early Reflection choices"None", "Small","Medium","Large","Huge","Long Random",
;"Short Backwards","Long Backwards","Strange1","Strange2"

if kER=1 then   ;none
aL=0
aR=0
elseif kER=2 then   ;small
aL  multitap    ga1mix*kERamp,0.0070 , 0.5281 , 0.0156 , 0.5038 , 0.0233 , 0.3408 , 0.0287 , 0.1764 , 0.0362 , 0.2514 , 0.0427 , 0.1855 , 0.0475 , 0.2229 , 0.0526 , 0.1345 , 0.0567 , 0.1037 , 0.0616 , 0.0837 , 0.0658 , 0.0418 , 0.0687 , 0.0781 , 0.0727 , 0.0654 , 0.0762 , 0.0369 , 0.0796 , 0.0192 , 0.0817 , 0.0278 , 0.0839 , 0.0132 , 0.0862 , 0.0073 , 0.0888 , 0.0089 , 0.0909 , 0.0087 , 0.0924 , 0.0065 , 0.0937 , 0.0015 , 0.0957 , 0.0019 , 0.0968 , 0.0012 , 0.0982 , 0.0004
aR  multitap    ga2mix*kERamp,0.0097 , 0.3672 , 0.0147 , 0.3860 , 0.0208 , 0.4025 , 0.0274 , 0.3310 , 0.0339 , 0.2234 , 0.0383 , 0.1326 , 0.0441 , 0.1552 , 0.0477 , 0.1477 , 0.0533 , 0.2054 , 0.0582 , 0.1242 , 0.0631 , 0.0707 , 0.0678 , 0.1061 , 0.0702 , 0.0331 , 0.0735 , 0.0354 , 0.0758 , 0.0478 , 0.0778 , 0.0347 , 0.0814 , 0.0185 , 0.0836 , 0.0157 , 0.0855 , 0.0197 , 0.0877 , 0.0171 , 0.0902 , 0.0078 , 0.0915 , 0.0032 , 0.0929 , 0.0026 , 0.0947 , 0.0014 , 0.0958 , 0.0018 , 0.0973 , 0.0007 , 0.0990 , 0.0007
elseif kER=3 then   ;medium
aL  multitap    ga1mix*kERamp,0.0215 , 0.3607 , 0.0435 , 0.2480 , 0.0566 , 0.3229 , 0.0691 , 0.5000 , 0.0842 , 0.1881 , 0.1010 , 0.2056 , 0.1140 , 0.1224 , 0.1224 , 0.3358 , 0.1351 , 0.3195 , 0.1442 , 0.2803 , 0.1545 , 0.1909 , 0.1605 , 0.0535 , 0.1680 , 0.0722 , 0.1788 , 0.1138 , 0.1886 , 0.0467 , 0.1945 , 0.1731 , 0.2010 , 0.0580 , 0.2096 , 0.0392 , 0.2148 , 0.0314 , 0.2201 , 0.0301 , 0.2278 , 0.0798 , 0.2357 , 0.0421 , 0.2450 , 0.0208 , 0.2530 , 0.0484 , 0.2583 , 0.0525 , 0.2636 , 0.0335 , 0.2694 , 0.0311 , 0.2764 , 0.0455 , 0.2817 , 0.0362 , 0.2874 , 0.0252 , 0.2914 , 0.0113 , 0.2954 , 0.0207 , 0.2977 , 0.0120 , 0.3029 , 0.0067 , 0.3054 , 0.0094 , 0.3084 , 0.0135 , 0.3127 , 0.0095 , 0.3157 , 0.0111 , 0.3178 , 0.0036 , 0.3202 , 0.0064 , 0.3221 , 0.0025 , 0.3252 , 0.0016 , 0.3268 , 0.0051 , 0.3297 , 0.0029 , 0.3318 , 0.0038 , 0.3345 , 0.0016 , 0.3366 , 0.0013 , 0.3386 , 0.0009 , 0.3401 , 0.0019 , 0.3416 , 0.0012 , 0.3431 , 0.0015 , 0.3452 , 0.0011 , 0.3471 , 0.0007 , 0.3488 , 0.0003
aR  multitap    ga2mix*kERamp,0.0146 , 0.5281 , 0.0295 , 0.3325 , 0.0450 , 0.3889 , 0.0605 , 0.2096 , 0.0792 , 0.5082 , 0.0881 , 0.1798 , 0.1051 , 0.3287 , 0.1132 , 0.1872 , 0.1243 , 0.1184 , 0.1338 , 0.1134 , 0.1480 , 0.1400 , 0.1594 , 0.2602 , 0.1721 , 0.0610 , 0.1821 , 0.1736 , 0.1908 , 0.0738 , 0.1978 , 0.1547 , 0.2084 , 0.0842 , 0.2187 , 0.0505 , 0.2256 , 0.0906 , 0.2339 , 0.0996 , 0.2428 , 0.0490 , 0.2493 , 0.0186 , 0.2558 , 0.0164 , 0.2596 , 0.0179 , 0.2658 , 0.0298 , 0.2698 , 0.0343 , 0.2750 , 0.0107 , 0.2789 , 0.0417 , 0.2817 , 0.0235 , 0.2879 , 0.0238 , 0.2938 , 0.0202 , 0.2965 , 0.0242 , 0.3015 , 0.0209 , 0.3050 , 0.0139 , 0.3097 , 0.0039 , 0.3137 , 0.0039 , 0.3165 , 0.0096 , 0.3205 , 0.0073 , 0.3231 , 0.0052 , 0.3255 , 0.0069 , 0.3273 , 0.0044 , 0.3298 , 0.0041 , 0.3326 , 0.0026 , 0.3348 , 0.0028 , 0.3372 , 0.0014 , 0.3389 , 0.0023 , 0.3413 , 0.0012 , 0.3428 , 0.0014 , 0.3443 , 0.0006 , 0.3458 , 0.0003 , 0.3474 , 0.0004 , 0.3486 , 0.0005 
elseif kER=4 then   ;large
aL  multitap    ga1mix*kERamp,0.0473 , 0.1344 , 0.0725 , 0.5048 , 0.0997 , 0.2057 , 0.1359 , 0.2231 , 0.1716 , 0.4355 , 0.1963 , 0.1904 , 0.2168 , 0.2274 , 0.2508 , 0.0604 , 0.2660 , 0.1671 , 0.2808 , 0.1725 , 0.3023 , 0.0481 , 0.3154 , 0.1940 , 0.3371 , 0.0651 , 0.3579 , 0.0354 , 0.3718 , 0.0504 , 0.3935 , 0.1609 , 0.4041 , 0.1459 , 0.4166 , 0.1355 , 0.4344 , 0.0747 , 0.4524 , 0.0173 , 0.4602 , 0.0452 , 0.4679 , 0.0643 , 0.4795 , 0.0377 , 0.4897 , 0.0159 , 0.4968 , 0.0433 , 0.5104 , 0.0213 , 0.5170 , 0.0115 , 0.5282 , 0.0102 , 0.5390 , 0.0091 , 0.5451 , 0.0146 , 0.5552 , 0.0371 , 0.5594 , 0.0192 , 0.5667 , 0.0218 , 0.5740 , 0.0176 , 0.5806 , 0.0242 , 0.5871 , 0.0167 , 0.5931 , 0.0184 , 0.6000 , 0.0075 , 0.6063 , 0.0060 , 0.6121 , 0.0068 , 0.6149 , 0.0138 , 0.6183 , 0.0044 , 0.6217 , 0.0035 , 0.6243 , 0.0026 , 0.6274 , 0.0017 , 0.6295 , 0.0098 , 0.6321 , 0.0054 , 0.6352 , 0.0022 , 0.6380 , 0.0011 , 0.6414 , 0.0012 , 0.6432 , 0.0062 , 0.6462 , 0.0024 , 0.6478 , 0.0032 , 0.6506 , 0.0009
aR  multitap    ga2mix*kERamp,0.0271 , 0.5190 , 0.0558 , 0.1827 , 0.0776 , 0.3068 , 0.1186 , 0.2801 , 0.1421 , 0.1526 , 0.1698 , 0.3249 , 0.1918 , 0.1292 , 0.2178 , 0.2828 , 0.2432 , 0.1128 , 0.2743 , 0.1884 , 0.2947 , 0.2023 , 0.3121 , 0.1118 , 0.3338 , 0.0660 , 0.3462 , 0.0931 , 0.3680 , 0.1295 , 0.3889 , 0.1430 , 0.4040 , 0.0413 , 0.4218 , 0.1122 , 0.4381 , 0.1089 , 0.4553 , 0.0691 , 0.4718 , 0.0699 , 0.4832 , 0.0375 , 0.4925 , 0.0119 , 0.5065 , 0.0181 , 0.5180 , 0.0500 , 0.5281 , 0.0228 , 0.5365 , 0.0072 , 0.5458 , 0.0366 , 0.5520 , 0.0065 , 0.5597 , 0.0115 , 0.5644 , 0.0105 , 0.5724 , 0.0063 , 0.5801 , 0.0118 , 0.5836 , 0.0198 , 0.5886 , 0.0172 , 0.5938 , 0.0081 , 0.5987 , 0.0094 , 0.6033 , 0.0029 , 0.6060 , 0.0078 , 0.6096 , 0.0149 , 0.6122 , 0.0102 , 0.6171 , 0.0144 , 0.6204 , 0.0014 , 0.6243 , 0.0038 , 0.6284 , 0.0111 , 0.6309 , 0.0107 , 0.6338 , 0.0036 , 0.6374 , 0.0035 , 0.6401 , 0.0015 , 0.6417 , 0.0052 , 0.6433 , 0.0019 , 0.6461 , 0.0033 , 0.6485 , 0.0007 
elseif kER=5 then   ;huge
aL  multitap    ga1mix*kERamp,0.0588 , 0.6917 , 0.1383 , 0.2512 , 0.2158 , 0.5546 , 0.2586 , 0.2491 , 0.3078 , 0.1830 , 0.3731 , 0.3712 , 0.4214 , 0.1398 , 0.4622 , 0.1870 , 0.5004 , 0.1652 , 0.5365 , 0.2254 , 0.5604 , 0.1423 , 0.5950 , 0.1355 , 0.6233 , 0.1282 , 0.6486 , 0.1312 , 0.6725 , 0.1009 , 0.7063 , 0.0324 , 0.7380 , 0.0968 , 0.7602 , 0.0169 , 0.7854 , 0.0530 , 0.8097 , 0.0342 , 0.8303 , 0.0370 , 0.8404 , 0.0173 , 0.8587 , 0.0281 , 0.8741 , 0.0164 , 0.8825 , 0.0045 , 0.8945 , 0.0181 , 0.9063 , 0.0057 , 0.9136 , 0.0030 , 0.9214 , 0.0065 , 0.9296 , 0.0059 , 0.9373 , 0.0021 , 0.9462 , 0.0087 , 0.9541 , 0.0035 , 0.9605 , 0.0013 , 0.9648 , 0.0043 , 0.9691 , 0.0014 , 0.9746 , 0.0011 , 0.9774 , 0.0032 , 0.9818 , 0.0020 , 0.9853 , 0.0042 , 0.9889 , 0.0030 , 0.9923 , 0.0034 , 0.9941 , 0.0021 , 0.9976 , 0.0009 , 0.9986 , 0.0008
aR  multitap    ga2mix*kERamp,0.0665 , 0.4406 , 0.1335 , 0.6615 , 0.1848 , 0.2284 , 0.2579 , 0.4064 , 0.3293 , 0.1433 , 0.3756 , 0.3222 , 0.4157 , 0.3572 , 0.4686 , 0.3280 , 0.5206 , 0.1134 , 0.5461 , 0.0540 , 0.5867 , 0.0473 , 0.6281 , 0.1018 , 0.6516 , 0.1285 , 0.6709 , 0.0617 , 0.6979 , 0.0360 , 0.7173 , 0.1026 , 0.7481 , 0.0621 , 0.7690 , 0.0585 , 0.7943 , 0.0340 , 0.8072 , 0.0170 , 0.8177 , 0.0092 , 0.8345 , 0.0369 , 0.8511 , 0.0369 , 0.8621 , 0.0251 , 0.8740 , 0.0109 , 0.8849 , 0.0135 , 0.8956 , 0.0118 , 0.9026 , 0.0187 , 0.9110 , 0.0182 , 0.9225 , 0.0034 , 0.9310 , 0.0083 , 0.9354 , 0.0058 , 0.9420 , 0.0040 , 0.9464 , 0.0028 , 0.9549 , 0.0090 , 0.9590 , 0.0076 , 0.9654 , 0.0030 , 0.9691 , 0.0041 , 0.9729 , 0.0009 , 0.9757 , 0.0024 , 0.9787 , 0.0049 , 0.9823 , 0.0040 , 0.9847 , 0.0025 , 0.9898 , 0.0005 , 0.9922 , 0.0022 , 0.9935 , 0.0025 , 0.9964 , 0.0027 , 0.9992 , 0.0007 
elseif kER=6 then   ;long random 
aL  multitap    ga1mix*kERamp,0.0131 , 0.6191 , 0.0518 , 0.4595 , 0.0800 , 0.4688 , 0.2461 , 0.2679 , 0.3826 , 0.1198 , 0.5176 , 0.2924 , 0.6806 , 0.0293 , 0.8211 , 0.0327 , 1.0693 , 0.3318 , 1.2952 , 0.1426 , 1.3079 , 0.1021 , 1.4337 , 0.1293 , 1.4977 , 0.2383 , 1.6702 , 0.0181 , 1.7214 , 0.2042 , 1.8849 , 0.0780 , 2.1279 , 0.0160 , 2.2836 , 0.0061 , 2.4276 , 0.0390 , 2.5733 , 0.1090 , 2.7520 , 0.0047 , 2.8650 , 0.0077 , 3.1026 , 0.0005
aR  multitap    ga2mix*kERamp,0.1591 , 0.4892 , 0.2634 , 0.1430 , 0.3918 , 0.0978 , 0.5004 , 0.0675 , 0.7004 , 0.1285 , 0.7251 , 0.0251 , 0.9368 , 0.4531 , 1.0770 , 0.0022 , 1.1426 , 0.0132 , 1.3189 , 0.1608 , 1.3550 , 0.0512 , 1.4347 , 0.0224 , 1.4739 , 0.1401 , 1.6996 , 0.1680 , 1.9292 , 0.1481 , 2.1435 , 0.2463 , 2.1991 , 0.1748 , 2.3805 , 0.1802 , 2.4796 , 0.0105 , 2.6615 , 0.0049 , 2.8115 , 0.0517 , 2.9687 , 0.0468 , 2.9899 , 0.0095 , 3.1554 , 0.0496 
elseif kER=7 then   ;short backwards
aL  multitap    ga1mix*kERamp,0.0022 , 0.0070 , 0.0040 , 0.0014 , 0.0054 , 0.0120 , 0.0085 , 0.0075 , 0.0106 , 0.0156 , 0.0141 , 0.0089 , 0.0176 , 0.0083 , 0.0200 , 0.0227 , 0.0225 , 0.0189 , 0.0253 , 0.0121 , 0.0284 , 0.0118 , 0.0367 , 0.0193 , 0.0431 , 0.0163 , 0.0477 , 0.0260 , 0.0558 , 0.0259 , 0.0632 , 0.0515 , 0.0694 , 0.0266 , 0.0790 , 0.0279 , 0.0873 , 0.0712 , 0.1075 , 0.1212 , 0.1286 , 0.0938 , 0.1433 , 0.1305 , 0.1591 , 0.0929 , 0.1713 , 0.2410 , 0.1982 , 0.1409 , 0.2144 , 0.3512 , 0.2672 , 0.5038 , 0.3293 , 0.3827
aR  multitap    ga2mix*kERamp,0.0019 , 0.0107 , 0.0030 , 0.0031 , 0.0049 , 0.0068 , 0.0066 , 0.0050 , 0.0098 , 0.0090 , 0.0132 , 0.0080 , 0.0165 , 0.0085 , 0.0196 , 0.0071 , 0.0221 , 0.0143 , 0.0247 , 0.0086 , 0.0316 , 0.0164 , 0.0374 , 0.0160 , 0.0416 , 0.0110 , 0.0511 , 0.0167 , 0.0619 , 0.0191 , 0.0730 , 0.0233 , 0.0887 , 0.0313 , 0.1037 , 0.0484 , 0.1114 , 0.0912 , 0.1219 , 0.0980 , 0.1482 , 0.1220 , 0.1806 , 0.2021 , 0.2057 , 0.2059 , 0.2382 , 0.2379 , 0.2550 , 0.2536 , 0.3112 , 0.6474
elseif kER=8 then   ;long backwards
aL  multitap    ga1mix*kERamp,0.0021 , 0.0008 , 0.0050 , 0.0006 , 0.0065 , 0.0007 , 0.0092 , 0.0014 , 0.0124 , 0.0028 , 0.0145 , 0.0032 , 0.0166 , 0.0015 , 0.0225 , 0.0018 , 0.0294 , 0.0030 , 0.0345 , 0.0077 , 0.0405 , 0.0056 , 0.0454 , 0.0096 , 0.0508 , 0.0088 , 0.0593 , 0.0082 , 0.0643 , 0.0074 , 0.0743 , 0.0182 , 0.0874 , 0.0103 , 0.0986 , 0.0270 , 0.1143 , 0.0135 , 0.1370 , 0.0327 , 0.1633 , 0.0420 , 0.1823 , 0.0708 , 0.2028 , 0.0842 , 0.2258 , 0.0962 , 0.2482 , 0.0513 , 0.2856 , 0.1035 , 0.3132 , 0.1229 , 0.3398 , 0.0721 , 0.3742 , 0.0996 , 0.4199 , 0.1817 , 0.4914 , 0.3000 , 0.5557 , 0.1649 , 0.6181 , 0.4180 , 0.6689 , 0.5216 , 0.7310 , 0.5185
aR  multitap    ga2mix*kERamp,0.0024 , 0.0007 , 0.0053 , 0.0006 , 0.0090 , 0.0034 , 0.0138 , 0.0026 , 0.0196 , 0.0016 , 0.0250 , 0.0080 , 0.0292 , 0.0051 , 0.0346 , 0.0039 , 0.0409 , 0.0089 , 0.0459 , 0.0067 , 0.0589 , 0.0132 , 0.0702 , 0.0192 , 0.0781 , 0.0211 , 0.0964 , 0.0239 , 0.1052 , 0.0201 , 0.1212 , 0.0226 , 0.1428 , 0.0147 , 0.1547 , 0.0418 , 0.1849 , 0.0232 , 0.2110 , 0.0975 , 0.2425 , 0.0620 , 0.2851 , 0.0963 , 0.3366 , 0.1248 , 0.3645 , 0.1321 , 0.4079 , 0.1293 , 0.4433 , 0.1425 , 0.5031 , 0.3787 , 0.5416 , 0.5061 , 0.6336 , 0.2865 , 0.7434 , 0.6477
elseif kER=9 then   ;strange1
aL  multitap    ga1mix*kERamp,0.0137 , 0.2939 , 0.0763 , 0.8381 , 0.2189 , 0.7019 , 0.2531 , 0.2366 , 0.3822 , 0.3756 , 0.4670 , 0.0751 , 0.4821 , 0.0870 , 0.4930 , 0.0794 , 0.5087 , 0.1733 , 0.5633 , 0.0657 , 0.6078 , 0.0218 , 0.6410 , 0.0113 , 0.6473 , 0.0246 , 0.6575 , 0.0513 , 0.6669 , 0.0431 , 0.6693 , 0.0392 , 0.6916 , 0.0050 , 0.6997 , 0.0192 , 0.7091 , 0.0186 , 0.7174 , 0.0105 , 0.7284 , 0.0254 , 0.7366 , 0.0221 , 0.7390 , 0.0112 , 0.7446 , 0.0029 , 0.7470 , 0.0211 , 0.7495 , 0.0006
aR  multitap    ga2mix*kERamp,0.0036 , 0.0052 , 0.0069 , 0.0105 , 0.0096 , 0.0190 , 0.0138 , 0.0235 , 0.0150 , 0.0018 , 0.0231 , 0.0012 , 0.0340 , 0.0022 , 0.0355 , 0.0154 , 0.0415 , 0.0057 , 0.0538 , 0.0237 , 0.0722 , 0.0037 , 0.0839 , 0.0291 , 0.1027 , 0.0500 , 0.1163 , 0.0367 , 0.1375 , 0.0114 , 0.1749 , 0.0156 , 0.2002 , 0.0635 , 0.2215 , 0.0660 , 0.2777 , 0.0517 , 0.3481 , 0.1666 , 0.3871 , 0.2406 , 0.4851 , 0.1022 , 0.5305 , 0.2043 , 0.5910 , 0.4109 , 0.6346 , 0.5573 , 0.7212 , 0.5535 , 0.8981 , 0.5854 
elseif kER=10 then  ;strange2
aL  multitap    ga1mix*kERamp,0.0306 , 0.3604 , 0.2779 , 0.6327 , 0.3687 , 0.2979 , 0.5186 , 0.4202 , 0.6927 , 0.3695 , 0.7185 , 0.2370 , 0.8703 , 0.3283 , 0.9138 , 0.1334 , 0.9610 , 0.1183 , 1.0656 , 0.2089 , 1.1153 , 0.0835 , 1.1933 , 0.0954 , 1.1974 , 0.0609 , 1.2972 , 0.1078 , 1.3243 , 0.0720 , 1.3498 , 0.0840 , 1.4191 , 0.0694 , 1.4479 , 0.0572 , 1.4992 , 0.0449 , 1.5256 , 0.0186 , 1.5704 , 0.0470 , 1.5852 , 0.0202 , 1.6090 , 0.0106 , 1.6165 , 0.0302 , 1.6440 , 0.0204 , 1.6557 , 0.0042 , 1.6582 , 0.0223 , 1.6810 , 0.0054 , 1.6814 , 0.0064 , 1.6943 , 0.0075 , 1.6988 , 0.0032 , 1.7064 , 0.0027 , 1.7073 , 0.0064 , 1.7124 , 0.0091 , 1.7150 , 0.0015 , 1.7218 , 0.0043 , 1.7308 , 0.0116 , 1.7335 , 0.0122 , 1.7355 , 0.0011 , 1.7433 , 0.0154 , 1.7466 , 0.0084 , 1.7487 , 0.0139 , 1.7503 , 0.0123 , 1.7520 , 0.0036 , 1.7561 , 0.0097 , 1.7565 , 0.0041 , 1.7586 , 0.0016 , 1.7657 , 0.0132 , 1.7704 , 0.0038 , 1.7748 , 0.0020 , 1.7777 , 0.0053 , 1.7783 , 0.0056 , 1.7791 , 0.0017 , 1.7818 , 0.0058 , 1.7822 , 0.0089 , 1.7844 , 0.0074 , 1.7863 , 0.0009 , 1.7878 , 0.0016 , 1.7899 , 0.0061 , 1.7919 , 0.0073 , 1.7925 , 0.0025 , 1.7941 , 0.0045 , 1.7956 , 0.0060 , 1.7958 , 0.0088 , 1.7963 , 0.0010 , 1.7965 , 0.0006 , 1.7977 , 0.0078 , 1.7988 , 0.0026
aR  multitap    ga2mix*kERamp,0.0011 , 0.0055 , 0.0022 , 0.0063 , 0.0027 , 0.0089 , 0.0034 , 0.0009 , 0.0049 , 0.0010 , 0.0064 , 0.0005 , 0.0069 , 0.0044 , 0.0091 , 0.0027 , 0.0103 , 0.0099 , 0.0112 , 0.0017 , 0.0131 , 0.0018 , 0.0142 , 0.0008 , 0.0159 , 0.0010 , 0.0188 , 0.0034 , 0.0207 , 0.0055 , 0.0245 , 0.0005 , 0.0262 , 0.0094 , 0.0312 , 0.0057 , 0.0344 , 0.0051 , 0.0402 , 0.0044 , 0.0404 , 0.0102 , 0.0433 , 0.0044 , 0.0435 , 0.0034 , 0.0489 , 0.0087 , 0.0512 , 0.0108 , 0.0605 , 0.0046 , 0.0702 , 0.0010 , 0.0734 , 0.0121 , 0.0839 , 0.0135 , 0.0985 , 0.0151 , 0.1014 , 0.0203 , 0.1041 , 0.0043 , 0.1114 , 0.0150 , 0.1216 , 0.0182 , 0.1293 , 0.0220 , 0.1299 , 0.0169 , 0.1312 , 0.0046 , 0.1453 , 0.0046 , 0.1527 , 0.0062 , 0.1545 , 0.0192 , 0.1578 , 0.0092 , 0.1655 , 0.0053 , 0.1754 , 0.0301 , 0.1967 , 0.0122 , 0.2289 , 0.0233 , 0.2353 , 0.0131 , 0.2632 , 0.0396 , 0.2873 , 0.0171 , 0.3348 , 0.0454 , 0.3872 , 0.0398 , 0.4484 , 0.0244 , 0.4913 , 0.0693 , 0.5424 , 0.0820 , 0.5668 , 0.1112 , 0.6054 , 0.0635 , 0.6669 , 0.1016 , 0.7211 , 0.1217 , 0.7541 , 0.1756 , 0.8759 , 0.1688 , 0.9106 , 0.1932 , 1.0384 , 0.1542 , 1.0732 , 0.1598 , 1.0767 , 0.2409 , 1.0988 , 0.1879 , 1.2422 , 0.3049 , 1.3480 , 0.3001 , 1.4961 , 0.3374 , 1.5886 , 0.2791 , 1.5957 , 0.3366 , 1.8248 , 0.2962 
endif

kin1 chnget "in1"
if kin1=1 then 
a1s=ga1mix+aL
elseif kin1=2 then
a2s=ga1mix+aL
elseif kin1=3 then
a3s=ga1mix+aL
elseif kin1=4 then
a4s=ga1mix+aL
elseif kin1=5 then
a5s=ga1mix+aL
elseif kin1=6 then
a6s=ga1mix+aL
elseif kin1=7 then
a7s=ga1mix+aL
elseif kin1=8 then
a8s=ga1mix+aL
elseif kin1=9 then
a9s=ga1mix+aL
elseif kin1=10 then
a10s=ga1mix+aL
elseif kin1=11 then
a11s=ga1mix+aL
elseif kin1=12 then
a12s=ga1mix+aL
elseif kin1=13 then
a13s=ga1mix+aL
elseif kin1=14 then
a14s=ga1mix+aL
elseif kin1=15 then
a15s=ga1mix+aL
elseif kin1=16 then
a16s=ga1mix+aL
elseif kin1=17 then
a17s=ga1mix+aL
elseif kin1=18 then
a18s=ga1mix+aL
elseif kin1=19 then
a19s=ga1mix+aL
elseif kin1=20 then
a20s=ga1mix+aL
elseif kin1=21 then
a21s=ga1mix+aL
elseif kin1=22 then
a22s=ga1mix+aL
elseif kin1=23 then
a23s=ga1mix+aL
elseif kin1=24 then
a24s=ga1mix+aL
elseif kin1=25 then
a25s=ga1mix+aL
endif

kin2 chnget "in2"
if kin2=1 then 
a1s=ga2mix+aR
elseif kin2=2 then
a2s=ga2mix+aR
elseif kin2=3 then
a3s=ga2mix+aR
elseif kin2=4 then
a4s=ga2mix+aR
elseif kin2=5 then
a5s=ga2mix+aR
elseif kin2=6 then
a6s=ga2mix+aR
elseif kin2=7 then
a7s=ga2mix+aR
elseif kin2=8 then
a8s=ga2mix+aR
elseif kin2=9 then
a9s=ga2mix+aR
elseif kin2=10 then
a10s=ga2mix+aR
elseif kin2=11 then
a11s=ga2mix+aR
elseif kin2=12 then
a12s=ga2mix+aR
elseif kin2=13 then
a13s=ga2mix+aR
elseif kin2=14 then
a14s=ga2mix+aR
elseif kin2=15 then
a15s=ga2mix+aR
elseif kin2=16 then
a16s=ga2mix+aR
elseif kin2=17 then
a17s=ga2mix+aR
elseif kin2=18 then
a18s=ga2mix+aR
elseif kin2=19 then
a19s=ga2mix+aR
elseif kin2=20 then
a20s=ga2mix+aR
elseif kin2=21 then
a21s=ga2mix+aR
elseif kin2=22 then
a22s=ga2mix+aR
elseif kin2=23 then
a23s=ga2mix+aR
elseif kin2=24 then
a24s=ga2mix+aR
elseif kin2=25 then
a25s=ga2mix+aR
endif

kin3 chnget "in3"
if kin3=1 then 
a1s=ga3mix
elseif kin3=2 then
a2s=ga3mix
elseif kin3=3 then
a3s=ga3mix
elseif kin3=4 then
a4s=ga3mix
elseif kin3=5 then
a5s=ga3mix
elseif kin3=6 then
a6s=ga3mix
elseif kin3=7 then
a7s=ga3mix
elseif kin3=8 then
a8s=ga3mix
elseif kin3=9 then
a9s=ga3mix
elseif kin3=10 then
a10s=ga3mix
elseif kin3=11 then
a11s=ga3mix
elseif kin3=12 then
a12s=ga3mix
elseif kin3=13 then
a13s=ga3mix
elseif kin3=14 then
a14s=ga3mix
elseif kin3=15 then
a15s=ga3mix
elseif kin3=16 then
a16s=ga3mix
elseif kin3=17 then
a17s=ga3mix
elseif kin3=18 then
a18s=ga3mix
elseif kin3=19 then
a19s=ga3mix
elseif kin3=20 then
a20s=ga3mix
elseif kin3=21 then
a21s=ga3mix
elseif kin3=22 then
a22s=ga3mix
elseif kin3=23 then
a23s=ga3mix
elseif kin3=24 then
a24s=ga3mix
elseif kin3=25 then
a25s=ga3mix
endif

kin4 chnget "in4"
if kin4=1 then 
a1s=ga4mix
elseif kin4=2 then
a2s=ga4mix
elseif kin4=3 then
a3s=ga4mix
elseif kin4=4 then
a4s=ga4mix
elseif kin4=5 then
a5s=ga4mix
elseif kin4=6 then
a6s=ga4mix
elseif kin4=7 then
a7s=ga4mix
elseif kin4=8 then
a8s=ga4mix
elseif kin4=9 then
a9s=ga4mix
elseif kin4=10 then
a10s=ga4mix
elseif kin4=11 then
a11s=ga4mix
elseif kin4=12 then
a12s=ga4mix
elseif kin4=13 then
a13s=ga4mix
elseif kin4=14 then
a14s=ga4mix
elseif kin4=15 then
a15s=ga4mix
elseif kin4=16 then
a16s=ga4mix
elseif kin4=17 then
a17s=ga4mix
elseif kin4=18 then
a18s=ga4mix
elseif kin4=19 then
a19s=ga4mix
elseif kin4=20 then
a20s=ga4mix
elseif kin4=21 then
a21s=ga4mix
elseif kin4=22 then
a22s=ga4mix
elseif kin4=23 then
a23s=ga4mix
elseif kin4=24 then
a24s=ga4mix
elseif kin4=25 then
a25s=ga4mix
endif

kin5 chnget "in5"
if kin5=1 then 
a1s=ga5mix
elseif kin5=2 then
a2s=ga5mix
elseif kin5=3 then
a3s=ga5mix
elseif kin5=4 then
a4s=ga5mix
elseif kin5=5 then
a5s=ga5mix
elseif kin5=6 then
a6s=ga5mix
elseif kin5=7 then
a7s=ga5mix
elseif kin5=8 then
a8s=ga5mix
elseif kin5=9 then
a9s=ga5mix
elseif kin5=10 then
a10s=ga5mix
elseif kin5=11 then
a11s=ga5mix
elseif kin5=12 then
a12s=ga5mix
elseif kin5=13 then
a13s=ga5mix
elseif kin5=14 then
a14s=ga5mix
elseif kin5=15 then
a15s=ga5mix
elseif kin5=16 then
a16s=ga5mix
elseif kin5=17 then
a17s=ga5mix
elseif kin5=18 then
a18s=ga5mix
elseif kin5=19 then
a19s=ga5mix
elseif kin5=20 then
a20s=ga5mix
elseif kin5=21 then
a21s=ga5mix
elseif kin5=22 then
a22s=ga5mix
elseif kin5=23 then
a23s=ga5mix
elseif kin5=24 then
a24s=ga5mix
elseif kin5=25 then
a25s=ga5mix
endif

kin6 chnget "in6"
if kin6=1 then 
a1s=ga6mix
elseif kin6=2 then
a2s=ga6mix
elseif kin6=3 then
a3s=ga6mix
elseif kin6=4 then
a4s=ga6mix
elseif kin6=5 then
a5s=ga6mix
elseif kin6=6 then
a6s=ga6mix
elseif kin6=7 then
a7s=ga6mix
elseif kin6=8 then
a8s=ga6mix
elseif kin6=9 then
a9s=ga6mix
elseif kin6=10 then
a10s=ga6mix
elseif kin6=11 then
a11s=ga6mix
elseif kin6=12 then
a12s=ga6mix
elseif kin6=13 then
a13s=ga6mix
elseif kin6=14 then
a14s=ga6mix
elseif kin6=15 then
a15s=ga6mix
elseif kin6=16 then
a16s=ga6mix
elseif kin6=17 then
a17s=ga6mix
elseif kin6=18 then
a18s=ga6mix
elseif kin6=19 then
a19s=ga6mix
elseif kin6=20 then
a20s=ga6mix
elseif kin6=21 then
a21s=ga6mix
elseif kin6=22 then
a22s=ga6mix
elseif kin6=23 then
a23s=ga6mix
elseif kin6=24 then
a24s=ga6mix
elseif kin6=25 then
a25s=ga6mix
endif

kin7 chnget "in7"
if kin7=1 then 
a1s=ga7mix
elseif kin7=2 then
a2s=ga7mix
elseif kin7=3 then
a3s=ga7mix
elseif kin7=4 then
a4s=ga7mix
elseif kin7=5 then
a5s=ga7mix
elseif kin7=6 then
a6s=ga7mix
elseif kin7=7 then
a7s=ga7mix
elseif kin7=8 then
a8s=ga7mix
elseif kin7=9 then
a9s=ga7mix
elseif kin7=10 then
a10s=ga7mix
elseif kin7=11 then
a11s=ga7mix
elseif kin7=12 then
a12s=ga7mix
elseif kin7=13 then
a13s=ga7mix
elseif kin7=14 then
a14s=ga7mix
elseif kin7=15 then
a15s=ga7mix
elseif kin7=16 then
a16s=ga7mix
elseif kin7=17 then
a17s=ga7mix
elseif kin7=18 then
a18s=ga7mix
elseif kin7=19 then
a19s=ga7mix
elseif kin7=20 then
a20s=ga7mix
elseif kin7=21 then
a21s=ga7mix
elseif kin7=22 then
a22s=ga7mix
elseif kin7=23 then
a23s=ga7mix
elseif kin7=24 then
a24s=ga7mix
elseif kin7=25 then
a25s=ga7mix
endif

kin8 chnget "in8"
if kin8=1 then 
a1s=ga8mix
elseif kin8=2 then
a2s=ga8mix
elseif kin8=3 then
a3s=ga8mix
elseif kin8=4 then
a4s=ga8mix
elseif kin8=5 then
a5s=ga8mix
elseif kin8=6 then
a6s=ga8mix
elseif kin8=7 then
a7s=ga8mix
elseif kin8=8 then
a8s=ga8mix
elseif kin8=9 then
a9s=ga8mix
elseif kin8=10 then
a10s=ga8mix
elseif kin8=11 then
a11s=ga8mix
elseif kin8=12 then
a12s=ga8mix
elseif kin8=13 then
a13s=ga8mix
elseif kin8=14 then
a14s=ga8mix
elseif kin8=15 then
a15s=ga8mix
elseif kin8=16 then
a16s=ga8mix
elseif kin8=17 then
a17s=ga8mix
elseif kin8=18 then
a18s=ga8mix
elseif kin8=19 then
a19s=ga8mix
elseif kin8=20 then
a20s=ga8mix
elseif kin8=21 then
a21s=ga8mix
elseif kin8=22 then
a22s=ga8mix
elseif kin8=23 then
a23s=ga8mix
elseif kin8=24 then
a24s=ga8mix
elseif kin8=25 then
a25s=ga8mix
endif

a1U,a1R,a1D,a1L,a1o meshEQ a1U,a2L,a6U,a1L,a1s,adel1,kFB
a2U,a2R,a2D,a2L,a2o meshEQ a2U,a3L,a7U,a1R,a2s,adel2,kFB
a3U,a3R,a3D,a3L,a3o meshEQ a3U,a4L,a8U,a2R,a3s,adel3,kFB
a4U,a4R,a4D,a4L,a4o meshEQ a4U,a5L,a9U,a3R,a4s,adel4,kFB
a5U,a5R,a5D,a5L,a5o meshEQ a5U,a5R,a10U,a4R,a5s,adel5,kFB

a6U,a6R,a6D,a6L,a6o meshEQ a1D,a7L,a11U,a6L,a6s,adel6,kFB
a7U,a7R,a7D,a7L,a7o meshEQ a2D,a8L,a12U,a6R,a7s,adel7,kFB
a8U,a8R,a8D,a8L,a8o meshEQ a3D,a9L,a13U,a7R,a8s,adel8,kFB
a9U,a9R,a9D,a9L,a9o meshEQ a4D,a10L,a14U,a8R,a9s,adel9,kFB
a10U,a10R,a10D,a10L,a10o meshEQ a5D,a10R,a15U,a9R,a10s,adel10,kFB

a11U,a11R,a11D,a11L,a11o meshEQ a6D,a12L,a16U,a11L,a11s,adel11,kFB
a12U,a12R,a12D,a12L,a12o meshEQ a7D,a13L,a17U,a11R,a12s,adel12,kFB
a13U,a13R,a13D,a13L,a13o meshEQ a8D,a14L,a18U,a12R,a13s,adel13,kFB
a14U,a14R,a14D,a14L,a14o meshEQ a9D,a15L,a19U,a13R,a14s,adel14,kFB
a15U,a15R,a15D,a15L,a15o meshEQ a10D,a15R,a20U,a14R,a15s,adel15,kFB

a16U,a16R,a16D,a16L,a16o meshEQ a11D,a17L,a21U,a16L,a16s,adel16,kFB
a17U,a17R,a17D,a17L,a17o meshEQ a12D,a18L,a22U,a16R,a17s,adel17,kFB
a18U,a18R,a18D,a18L,a18o meshEQ a13D,a19L,a23U,a17R,a18s,adel18,kFB
a19U,a19R,a19D,a19L,a19o meshEQ a14D,a20L,a24U,a18R,a19s,adel19,kFB
a20U,a20R,a20D,a20L,a20o meshEQ a15D,a20R,a25U,a19R,a20s,adel20,kFB

a21U,a21R,a21D,a21L,a21o meshEQ a16D,a22L,a21D,a21L,a21s,adel21,kFB
a22U,a22R,a22D,a22L,a22o meshEQ a17D,a23L,a22D,a21R,a22s,adel22,kFB
a23U,a23R,a23D,a23L,a23o meshEQ a18D,a24L,a23D,a22R,a23s,adel23,kFB
a24U,a24R,a24D,a24L,a24o meshEQ a19D,a25L,a24D,a23R,a24s,adel24,kFB
a25U,a25R,a25D,a25L,a25o meshEQ a20D,a25R,a25D,a24R,a25s,adel25,kFB

kout1 chnget "out1"
if kout1=1 then 
a1out=a1o
elseif kout1=2 then
a1out=a2o
elseif kout1=3 then
a1out=a3o
elseif kout1=4 then
a1out=a4o
elseif kout1=5 then
a1out=a5o
elseif kout1=6 then
a1out=a6o
elseif kout1=7 then
a1out=a7o
elseif kout1=8 then
a1out=a8o
elseif kout1=9 then
a1out=a9o
elseif kout1=10 then
a1out=a10o
elseif kout1=11 then
a1out=a11o
elseif kout1=12 then
a1out=a12o
elseif kout1=13 then
a1out=a13o
elseif kout1=14 then
a1out=a14o
elseif kout1=15 then
a1out=a15o
elseif kout1=16 then
a1out=a16o
elseif kout1=17 then
a1out=a17o
elseif kout1=18 then
a1out=a18o
elseif kout1=19 then
a1out=a19o
elseif kout1=20 then
a1out=a20o
elseif kout1=21 then
a1out=a21o
elseif kout1=22 then
a1out=a22o
elseif kout1=23 then
a1out=a23o
elseif kout1=24 then
a1out=a24o
elseif kout1=25 then
a1out=a25o
endif

kout2 chnget "out2"
if kout2=1 then 
a2out=a1o
elseif kout2=2 then
a2out=a2o
elseif kout2=3 then
a2out=a3o
elseif kout2=4 then
a2out=a4o
elseif kout2=5 then
a2out=a5o
elseif kout2=6 then
a2out=a6o
elseif kout2=7 then
a2out=a7o
elseif kout2=8 then
a2out=a8o
elseif kout2=9 then
a2out=a9o
elseif kout2=10 then
a2out=a10o
elseif kout2=11 then
a2out=a11o
elseif kout2=12 then
a2out=a12o
elseif kout2=13 then
a2out=a13o
elseif kout2=14 then
a2out=a14o
elseif kout2=15 then
a2out=a15o
elseif kout2=16 then
a2out=a16o
elseif kout2=17 then
a2out=a17o
elseif kout2=18 then
a2out=a18o
elseif kout2=19 then
a2out=a19o
elseif kout2=20 then
a2out=a20o
elseif kout2=21 then
a2out=a21o
elseif kout2=22 then
a2out=a22o
elseif kout2=23 then
a2out=a23o
elseif kout2=24 then
a2out=a24o
elseif kout2=25 then
a2out=a25o
endif

kout3 chnget "out3"
if kout3=1 then 
a3out=a1o
elseif kout3=2 then
a3out=a2o
elseif kout3=3 then
a3out=a3o
elseif kout3=4 then
a3out=a4o
elseif kout3=5 then
a3out=a5o
elseif kout3=6 then
a3out=a6o
elseif kout3=7 then
a3out=a7o
elseif kout3=8 then
a3out=a8o
elseif kout3=9 then
a3out=a9o
elseif kout3=10 then
a3out=a10o
elseif kout3=11 then
a3out=a11o
elseif kout3=12 then
a3out=a12o
elseif kout3=13 then
a3out=a13o
elseif kout3=14 then
a3out=a14o
elseif kout3=15 then
a3out=a15o
elseif kout3=16 then
a3out=a16o
elseif kout3=17 then
a3out=a17o
elseif kout3=18 then
a3out=a18o
elseif kout3=19 then
a3out=a19o
elseif kout3=20 then
a3out=a20o
elseif kout3=21 then
a3out=a21o
elseif kout3=22 then
a3out=a22o
elseif kout3=23 then
a3out=a23o
elseif kout3=24 then
a3out=a24o
elseif kout3=25 then
a3out=a25o
endif

kout4 chnget "out4"
if kout4=1 then 
a4out=a1o
elseif kout4=2 then
a4out=a2o
elseif kout4=3 then
a4out=a3o
elseif kout4=4 then
a4out=a4o
elseif kout4=5 then
a4out=a5o
elseif kout4=6 then
a4out=a6o
elseif kout4=7 then
a4out=a7o
elseif kout4=8 then
a4out=a8o
elseif kout4=9 then
a4out=a9o
elseif kout4=10 then
a4out=a10o
elseif kout4=11 then
a4out=a11o
elseif kout4=12 then
a4out=a12o
elseif kout4=13 then
a4out=a13o
elseif kout4=14 then
a4out=a14o
elseif kout4=15 then
a4out=a15o
elseif kout4=16 then
a4out=a16o
elseif kout4=17 then
a4out=a17o
elseif kout4=18 then
a4out=a18o
elseif kout4=19 then
a4out=a19o
elseif kout4=20 then
a4out=a20o
elseif kout4=21 then
a4out=a21o
elseif kout4=22 then
a4out=a22o
elseif kout4=23 then
a4out=a23o
elseif kout4=24 then
a4out=a24o
elseif kout4=25 then
a4out=a25o
endif

kout5 chnget "out5"
if kout5=1 then 
a5out=a1o
elseif kout5=2 then
a5out=a2o
elseif kout5=3 then
a5out=a3o
elseif kout5=4 then
a5out=a4o
elseif kout5=5 then
a5out=a5o
elseif kout5=6 then
a5out=a6o
elseif kout5=7 then
a5out=a7o
elseif kout5=8 then
a5out=a8o
elseif kout5=9 then
a5out=a9o
elseif kout5=10 then
a5out=a10o
elseif kout5=11 then
a5out=a11o
elseif kout5=12 then
a5out=a12o
elseif kout5=13 then
a5out=a13o
elseif kout5=14 then
a5out=a14o
elseif kout5=15 then
a5out=a15o
elseif kout5=16 then
a5out=a16o
elseif kout5=17 then
a5out=a17o
elseif kout5=18 then
a5out=a18o
elseif kout5=19 then
a5out=a19o
elseif kout5=20 then
a5out=a20o
elseif kout5=21 then
a5out=a21o
elseif kout5=22 then
a5out=a22o
elseif kout5=23 then
a5out=a23o
elseif kout5=24 then
a5out=a24o
elseif kout5=25 then
a5out=a25o
endif

kout6 chnget "out6"
if kout6=1 then 
a6out=a1o
elseif kout6=2 then
a6out=a2o
elseif kout6=3 then
a6out=a3o
elseif kout6=4 then
a6out=a4o
elseif kout6=5 then
a6out=a5o
elseif kout6=6 then
a6out=a6o
elseif kout6=7 then
a6out=a7o
elseif kout6=8 then
a6out=a8o
elseif kout6=9 then
a6out=a9o
elseif kout6=10 then
a6out=a10o
elseif kout6=11 then
a6out=a11o
elseif kout6=12 then
a6out=a12o
elseif kout6=13 then
a6out=a13o
elseif kout6=14 then
a6out=a14o
elseif kout6=15 then
a6out=a15o
elseif kout6=16 then
a6out=a16o
elseif kout6=17 then
a6out=a17o
elseif kout6=18 then
a6out=a18o
elseif kout6=19 then
a6out=a19o
elseif kout6=20 then
a6out=a20o
elseif kout6=21 then
a6out=a21o
elseif kout6=22 then
a6out=a22o
elseif kout6=23 then
a6out=a23o
elseif kout6=24 then
a6out=a24o
elseif kout6=25 then
a6out=a25o
endif

kout7 chnget "out7"
if kout7=1 then 
a7out=a1o
elseif kout7=2 then
a7out=a2o
elseif kout7=3 then
a7out=a3o
elseif kout7=4 then
a7out=a4o
elseif kout7=5 then
a7out=a5o
elseif kout7=6 then
a7out=a6o
elseif kout7=7 then
a7out=a7o
elseif kout7=8 then
a7out=a8o
elseif kout7=9 then
a7out=a9o
elseif kout7=10 then
a7out=a10o
elseif kout7=11 then
a7out=a11o
elseif kout7=12 then
a7out=a12o
elseif kout7=13 then
a7out=a13o
elseif kout7=14 then
a7out=a14o
elseif kout7=15 then
a7out=a15o
elseif kout7=16 then
a7out=a16o
elseif kout7=17 then
a7out=a17o
elseif kout7=18 then
a7out=a18o
elseif kout7=19 then
a7out=a19o
elseif kout7=20 then
a7out=a20o
elseif kout7=21 then
a7out=a21o
elseif kout7=22 then
a7out=a22o
elseif kout7=23 then
a7out=a23o
elseif kout7=24 then
a7out=a24o
elseif kout7=25 then
a7out=a25o
endif

kout8 chnget "out8"
if kout8=1 then 
a8out=a1o
elseif kout8=2 then
a8out=a2o
elseif kout8=3 then
a8out=a3o
elseif kout8=4 then
a8out=a4o
elseif kout8=5 then
a8out=a5o
elseif kout8=6 then
a8out=a6o
elseif kout8=7 then
a8out=a7o
elseif kout8=8 then
a8out=a8o
elseif kout8=9 then
a8out=a9o
elseif kout8=10 then
a8out=a10o
elseif kout8=11 then
a8out=a11o
elseif kout8=12 then
a8out=a12o
elseif kout8=13 then
a8out=a13o
elseif kout8=14 then
a8out=a14o
elseif kout8=15 then
a8out=a15o
elseif kout8=16 then
a8out=a16o
elseif kout8=17 then
a8out=a17o
elseif kout8=18 then
a8out=a18o
elseif kout8=19 then
a8out=a19o
elseif kout8=20 then
a8out=a20o
elseif kout8=21 then
a8out=a21o
elseif kout8=22 then
a8out=a22o
elseif kout8=23 then
a8out=a23o
elseif kout8=24 then
a8out=a24o
elseif kout8=25 then
a8out=a25o
endif

garev1=dcblock2(a1out)
garev2=dcblock2(a2out)
garev3=dcblock2(a3out)
garev4=dcblock2(a4out)
garev5=dcblock2(a5out)
garev6=dcblock2(a6out)
garev7=dcblock2(a7out)
garev8=dcblock2(a8out)
endin

instr 60	; record file
irecch chnget "recch"
ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname   sprintf "MVerb_%s", Sfilnam
 if gkrecord==1 then			; record
  if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource)
  elseif irecch=2 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource) 
  elseif irecch=3 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource)
  elseif irecch=4 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource)
  elseif irecch=5 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource)
  elseif irecch=6 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource),(garev6*gkFX)+(ga6mix*gksource)
  elseif irecch=7 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource),(garev6*gkFX)+(ga6mix*gksource),(garev7*gkFX)+(ga7mix*gksource)
  elseif irecch=8 then
   fout gSname,imode,(garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource),(garev6*gkFX)+(ga6mix*gksource),(garev7*gkFX)+(ga7mix*gksource),(garev8*gkFX)+(ga8mix*gksource)
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	61	; play file
 if gkplay==0 then
  turnoff
 endif 
 ichnl filenchnls gSname
 if ichnl==1 then
    a1	diskin2	gSname,1
 elseif ichnl==2 then
    a1,a2	diskin2	gSname,1
 elseif ichnl==3 then
    a1,a2,a3	diskin2	gSname,1
 elseif ichnl==4 then
   a1,a2,a3,a4	diskin2	gSname,1
 elseif ichnl==5 then
   a1,a2,a3,a4,a5	diskin2	gSname,1
 elseif ichnl==6 then
   a1,a2,a3,a4,a5,a6	diskin2	gSname,1
 elseif ichnl==7 then
   a1,a2,a3,a4,a5,a6,a7	diskin2	gSname,1
 elseif ichnl==8 then
   a1,a2,a3,a4,a5,a6,a7,a8	diskin2	gSname,1
 endif
 	outo	a1,a2,a3,a4,a5,a6,a7,a8
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play"
endin

instr 100   ;instrument to monitor MIDI controller numbers, creates global MIDI outputs that are evaluated by instr 110-300         
            ;also controls popup fpr latched LowPass
gkstatus,gkchan,gkdata1,gkdata2 midiin
if changed(gkstatus)==1 then  
    if gkstatus==176 then
    chnset gkdata1,"CtrlNum" ;displays current controller number in GUI
    endif
endif
endin

instr 101 ;MIDI mapping (input amp, size factor, FB, and Early Reflection amp
kmapliveamp chnget "mapliveamp"
kmapliveampX chnget "mapliveampX"
kmapDFact chnget "mapDFact"
kmapDFactX chnget "mapDFactX"
kmapFB chnget "mapFB"
kmapFBX chnget "mapFBX"
kmapERamp chnget "mapERamp"
kmapERampX chnget "mapERampX"
kmaprmax chnget "maprmax"
kmaprmaxX chnget "maprmaxX"
kmaprrate chnget "maprrate"
kmaprrateX chnget "maprrateX"
kmaprratedev chnget "maprratedev"
kmaprratedevX chnget "maprratedevX"
kmapmix chnget "mapmix"
kmapmixX chnget "mapmixX"
kmapport chnget "mapport"
kmapportX chnget "mapportX"
kmapsfspeed chnget "mapsfspeed"
kmapsfspeedX chnget "mapsfspeedX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapliveamp==1 then
      turnoff2 102,2,0
      event "i",102,0,999999999
    elseif kmapDFact==1 then
      turnoff2 103,2,0
      event "i",103,0,999999999
    elseif kmapFB==1 then
      turnoff2 104,2,0
      event "i",104,0,999999999
    elseif kmapERamp==1 then
      turnoff2 105,2,0
      event "i",105,0,999999999
    elseif kmaprmax==1 then
      turnoff2 106,2,0
      event "i",106,0,999999999
    elseif kmaprrate==1 then
      turnoff2 107,2,0
      event "i",107,0,999999999
    elseif kmaprratedev==1 then
      turnoff2 108,2,0
      event "i",108,0,999999999
    elseif kmapmix==1 then
      turnoff2 109,2,0
      event "i",109,0,999999999
    elseif kmapport==1 then
      turnoff2 110,2,0
      event "i",110,0,999999999
    elseif kmapsfspeed==1 then
      turnoff2 111,2,0
      event "i",111,0,999999
    endif
  endif
endif

if kmapliveampX==1 then
  turnoff2 102,2,0
elseif kmapDFactX==1 then
  turnoff2 103,2,0
elseif kmapFBX==1 then
  turnoff2 104,2,0
elseif kmapERampX==1 then
  turnoff2 105,2,0
elseif kmaprmaxX==1 then
  turnoff2 106,2,0
elseif kmaprrateX==1 then
  turnoff2 107,2,0
elseif kmaprratedevX==1 then
  turnoff2 108,2,0
elseif kmapmixX==1 then
  turnoff2 109,2,0
elseif kmapportX==1 then
  turnoff2 110,2,0
elseif kmapsfspeedX==1 then
  turnoff2 111,2,0
endif

endin

instr 102
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveamp"
endin

instr 103
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "DFact"
endin
instr 104
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "FB"
endin

instr 105
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ERamp"
endin

instr 106
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rmax"
endin

instr 107
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.05,250 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rrate"
endin

instr 108
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "rratedev"
endin

instr 109
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "mix"
endin

instr 110
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "port"
endin

instr 111
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.25,4 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "sfspeed"
endin

instr 120 ;MIDI mapping EQ
kmapboost chnget "mapboost"
kmapboostX chnget "mapboostX"
kmapf1 chnget "mapf1"
kmapf1X chnget "mapf1X"
kmapQ chnget "mapQ"
kmapQX chnget "mapQX"
kmapQ2 chnget "mapQ2"
kmapQ2X chnget "mapQ2X"
kmapdisp chnget "mapdisp"
kmapdispX chnget "mapdispX"

if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapboost==1 then
      turnoff2 121,2,0
      event "i",121,0,999999999
    elseif kmapf1==1 then
      turnoff2 122,2,0
      event "i",122,0,999999999
    elseif kmapQ==1 then
      turnoff2 123,2,0
      event "i",123,0,999999999
    elseif kmapQ2==1 then
      turnoff2 124,2,0
      event "i",124,0,999999999
    elseif kmapdisp==1 then
      turnoff2 125,2,0
      event "i",125,0,999999999
    endif
  endif
endif

if kmapboostX==1 then
  turnoff2 121,2,0
elseif kmapf1X==1 then
  turnoff2 122,2,0
elseif kmapQX==1 then
  turnoff2 123,2,0
elseif kmapQ2X==1 then
  turnoff2 124,2,0
elseif kmapdispX==1 then
  turnoff2 125,2,0
endif

endin

instr 121
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.5,1.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "boost"
endin

instr 122
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,100,20000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "f1"
endin

instr 123
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.5,99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Q"
endin

instr 124
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.5,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Q2"
endin

instr 125
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "disp"
endin

instr   200 ;audio outputs
outo    (garev1*gkFX)+(ga1mix*gksource),(garev2*gkFX)+(ga2mix*gksource),(garev3*gkFX)+(ga3mix*gksource),(garev4*gkFX)+(ga4mix*gksource),(garev5*gkFX)+(ga5mix*gksource),(garev6*gkFX)+(ga6mix*gksource),(garev7*gkFX)+(ga7mix*gksource),(garev8*gkFX)+(ga8mix*gksource) 
endin

instr 201   ;clear global audio
clear   ga1mix,ga2mix,ga3mix,ga4mix,ga5mix,ga6mix,ga7mix,ga8mix,garev1,garev2,garev3,garev4,garev5,garev6,garev7,garev8,gamic1,gamic2,gamic3,gamic4,gamic5,gamic6,gamic7,gamic8
endin

</CsInstruments>
<CsScore>

i1 0 999999
i5 0 999999
i10 0 999999
i100 0 999999
i101 0 999999
i120 0 999999
i200 0 999999
i201 0 999999

</CsScore>
</CsoundSynthesizer>